unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, dglOpenGL;

type

  { TForm1 }

  TForm1 = class(TForm)
    OpenGLControl1: TOpenGLControl;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);


  public
    qaudricParam: PGLUQuadric;
    winkel: single;
    procedure Rad(d: single; speichen: integer; startwinkel: single);
  end;

var
  Form1: TForm1;

implementation


{ TForm1 }

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  winkel += 3;
  if winkel > 360 then begin
    winkel -= 360;
  end;
  Rad(0.5, 7, winkel);

  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.Rad(d: single; speichen: integer; startwinkel: single);
var
  i: integer;
  l: single;
begin
  gluQuadricDrawStyle(qaudricParam, GLU_FILL);
  l := d / 20;
  glRotatef(startwinkel, 0, 0, 1);

  for i := 0 to speichen - 1 do begin
    glRotatef(360 / speichen, 0, 0, 1);

    glBegin(GL_QUADS);
    glColor3f(1, 0.5, 0.5);
    glVertex3f(-l, 0, 0);
    glVertex3f(l, 0, 0);
    glVertex3f(l, d - l, 0);
    glVertex3f(-l, d - l, 0);
    glEnd();
  end;

  glTranslatef(0, 0, -0.1); // Nabe/Spurkranz vor Speicehn
  glColor3f(1.0, 0.0, 0.0);
  gluDisk(qaudricParam, d / 10 * 9, d, 36, 1);
  gluDisk(qaudricParam, 0.0, d / 6, 36, 1);

  glTranslatef(0, 0, -0.1); // Schraube vor Nabe
  glColor3f(0.0, 0.0, 0.0);
  gluDisk(qaudricParam, 0.0, d / 10, 6, 1);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ClientHeight := ClientWidth;
  InitOpenGL;
  OpenGLControl1.MakeCurrent;
  ReadExtensions;
  ReadImplementationProperties;
  qaudricParam := @gluNewQuadric;

end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  glViewport(0, 0, ClientHeight, ClientHeight);
end;


initialization

  {$I unit1.lrs}

end.
